<script setup lang="ts">
useHead({ title: 'Offline data import' })

type ImportOfflineRequest = {
  hello: string
}

type ImportOfflineResponse = {
  moveCode: string
  movePassword: string
}

const config = useRuntimeConfig()

const status = ref<'wait' | 'uploading' | 'failed' | 'success'>('wait')

const selectedFile = ref<File | null>(null)
const selectedFileReader = new FileReader()
const requestData = ref<ImportOfflineRequest | null>(null)
const responseData = ref<ImportOfflineResponse | null>(null)

const uploadImportFile = async (requestData: ImportOfflineRequest) => {
  const resp: ImportOfflineResponse = await $fetch(
    `${config.public.apiUrl}/api/player/import/offline`,
    {
      method: 'POST',
      body: requestData
    }
  )
  return resp
}

const onSelectFile = (file: File) => {
  selectedFile.value = file
  selectedFileReader.onload = () => {
    const parsedText = selectedFileReader.result
    if (typeof parsedText !== 'string') {
      throw new TypeError('Invalid file format')
    }
    requestData.value = JSON.parse(parsedText)
  }
  selectedFileReader.readAsText(selectedFile.value)
}

const onClickImportData = async () => {
  if (!selectedFile.value) return
  if (!requestData.value) return
  status.value = 'uploading'
  try {
    const res = await uploadImportFile(requestData.value)
    responseData.value = res
    status.value = 'success'
  } catch {
    status.value = 'failed'
  }
}
</script>

<template>
  <v-container>
    <v-row justify="center">
      <!-- header -->
      <v-col class="my-2" cols="12" md="10" lg="8">
        <h1 class="title text-brown-darken-4">Offline data import</h1>
        <p class="subtitle text-brown-darken-4">
          This page is for importing data.json, which stores user data dumped
          from the offline app. If you don't know what this is, please make a
          new account instead.
        </p>
        <p v-if="false" class="subtitle text-brown-darken-4">
          If you have key.d and o.d instead of out.json, you can dump the data
          from
          <a href="./offline-dump">offline data dumper</a>.
        </p>
      </v-col>
      <!-- body -->
      <v-col class="my-2" cols="12" md="10" lg="10" xd="8">
        <v-container>
          <v-row align="stretch" justify="center">
            <v-col
              v-if="status !== 'success'"
              class="my-2 text-center fill-height"
              cols="12"
              md="10"
              lg="6"
            >
              <v-row>
                <v-col class="my-2 text-center" cols="12">
                  <file-select-button
                    :title="
                      selectedFile ? selectedFile.name : 'Select a json file'
                    "
                    :accept="['application/json']"
                    @update:file="onSelectFile"
                  />
                </v-col>
              </v-row>
              <v-btn
                size="x-large"
                class="mt-4 w-100 bg-brown-darken-2"
                :disabled="!selectedFile || status === 'uploading'"
                @click="onClickImportData"
                >Import user data</v-btn
              >
              <template v-if="status === 'uploading'">
                <p class="mt-3">Creating your account, please wait a bit...</p>
                <v-progress-linear :value="true" color="primary" height="10" />
              </template>
            </v-col>
            <v-col
              v-if="status === 'success'"
              class="my-2 text-center"
              cols="12"
              md="10"
              lg="6"
            >
              <v-card class="pa-2">
                <v-container class="text-left">
                  <v-row class="title text-brown-darken-4">
                    <h2 class="subtitle">Account import succeed!</h2>
                  </v-row>
                  <v-row>
                    <p>
                      Please use below transfer codes in the game app to
                      continue.
                    </p>
                  </v-row>
                  <v-row v-if="responseData != null" class="mt-8 text-left">
                    <v-col cols="12" md="6" lg="6">
                      <p class="font-weight-bold">Your Transfer Code</p>
                    </v-col>
                    <v-col cols="12" md="6" lg="6">
                      <p v-text="responseData.moveCode" />
                    </v-col>
                    <v-col cols="12" md="6" lg="6">
                      <p class="font-weight-bold">Your Transfer Password</p>
                    </v-col>
                    <v-col cols="12" md="6" lg="6">
                      <p v-text="responseData.movePassword" />
                    </v-col>
                    <v-col cols="12" class="mt-4">
                      <p class="font-weight-bold">
                        We don't show this transfer code and password again,
                        please copy these values to another app!
                      </p>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card>
            </v-col>
            <v-col
              v-if="status === 'failed'"
              class="my-2 text-center"
              cols="12"
              md="10"
              lg="6"
            >
              <v-card class="pa-2 h-100">
                <v-container>
                  <v-row class="text-left">
                    <h2 class="subtitle">Account import failed!</h2>
                    <p>
                      Please check your json file is correct, and try again! If
                      it still doesn't work, please contact us.
                    </p>
                  </v-row>
                </v-container>
              </v-card>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
    </v-row>
  </v-container>
</template>
